try {
 

    //
    // Global variables
    //
    var PLUGINS_FOLDER = new Folder(app.path+'/'+localize('$$$/private/Plugins/DefaultPluginFolder=Plug-Ins'));
    var FLASH_PANELS_FOLDER = new Folder(PLUGINS_FOLDER+'/'+localize('$$$/private/Plugins/FlashFolder=Panels'));

    eval('//@include "'+FLASH_PANELS_FOLDER+'/Tutorial Builder/TutorialBuilderClean.jsx"\r\n');

    //var defaultDestinationFolder = FLASH_PANELS_FOLDER;
    var defaultDestinationFolder = Folder.temp;
    var saveToFolder = Folder.desktop + "/TBResults";
    var destinationFolder = saveToFolder;
    var outFile = null;
    var slCodeFile = Folder.desktop + "/ScriptingListenerJS.log";

    var defaultTitle = "Tutorial Builder 101";
    var defaultCaption = "How to use Tutorial Builder";
    var defaultAuthor = "Adobe CTL";
    var defaultDescription = "This tutorial was generated automatically from our new Tutorial Builder plugin for PS. Click on the links and watch in Photoshop.";

    var title = defaultTitle;
    var caption = defaultCaption;
    var author = defaultAuthor;
    var description = defaultDescription;

    var maxPixelRes = 1024*1024;
    
isCS6 = function()  { return app.version.match(/^13\./); };
isCS5 = function()  { return app.version.match(/^12\./); };
isCS4 = function()  { return app.version.match(/^11\./); };

    //app.notifiersEnabled = true;
//    var eventFile = new File(FLASH_PANELS_FOLDER+'/Tutorial Builder/saveBeforeImage.jsx');
//    if(app.notifiers.length == 0)
//        app.notifiers.add('Opn ', eventFile);

function LogEventToHeadlights(subcategoryStr, eventRecordStr, count) {
    if (isCS6() == null) {
        return;
    }
    
    var kheadlightsLogEventStr = stringIDToTypeID("headlightsLog");
    var ksubcategoryStr = stringIDToTypeID("subcategory"); 
    var keventRecordStr = stringIDToTypeID("eventRecord"); 
    var kcountStr = stringIDToTypeID("count");      
    var d = new ActionDescriptor;	
    
    // subcategory and event name are mandatory
    d.putString(ksubcategoryStr, subcategoryStr);
    d.putString(keventRecordStr, eventRecordStr);

    // count is optional
    if (typeof(count) != "undefined")
        d.putInteger(kcountStr, count);
		
    executeAction(kheadlightsLogEventStr, d, DialogModes.NO); 
}


    function imageOpened(){ 
           askAboutBeforeImage();        
    }

function getNumDocuments(){
	var xml = "<object>";
	xml += convertToXML(app.documents.length, "numDocs");
	xml += "</object>"
	    return xml; 
    }

    function convertToXML(property, identifier){
	var type = typeof property;
	var xml = '<property id = "' + identifier + '" >';
   
	switch(type){
	case "number":
	    xml += "<number>";
	    xml += property.toString();
	    xml += "</number>";
	    break;
	case "boolean":
	    xml += "<" + property.toString() + "/>";
	    break;
	case "string":
	    xml += "<string>";
	    xml += property.toString();
	    xml += "</string>";
	    break;
	case "object":
	    // Object case is currently not supported
	    alert("Object case is currently not supported");
	    //xml += "<object>";
	    //for(var i in property)
	    //   xml += convertToXML(property[i], 
	    //xml += "</object>";
	    break;
	case "undefined":
	    xml += "<string>undefined</string>";
	    break;
	default:
	    alert("Type " + type + " is unknown.");
	    return "";
	}
	xml += '</property>';
	return xml;
    }

    function buildTutorial(){
	try{
	    //var thisFile = new File($.fileName);
	    //var parentFolder = thisFile.parent;        
	    //alert(FLASH_PANELS_FOLDER);
	    makeTutorial(FLASH_PANELS_FOLDER+'/Tutorial Builder/', destinationFolder, title, caption, author, description);
	    var t = "Done creating the '"+title+"' tutorial!";
	    alert(t);
        
	} catch (e) {
         
	    alert(e);
	    throw e;
	}
    }


    function startDemo() {
	try {
	    //clean up before and after images
        
	    var dFolder = Folder(defaultDestinationFolder);
	    if(!dFolder.exists)
		dFolder.create();

	    var currSLFile = new File(slCodeFile);
	    // erase currSLFile
	    currSLFile.open('w');
	    if (currSLFile) {
		currSLFile.close();
	    }

	    outFile = new File(defaultDestinationFolder+'/ScriptingListenerJS.log');
	    outFile.open('w');
	    if (outFile) {
		outFile.remove();
		outFile.close();
	    }
	    outFile = null;

	    var beforeImage = File(defaultDestinationFolder+'/before.png');
	    if(beforeImage.exists)
            beforeImage.remove();

	    var afterImage = File(defaultDestinationFolder+'/after.png');
	    if (afterImage.exists)
            afterImage.remove();	

	    var assetsFolder = Folder(defaultDestinationFolder+'/assets');
	    if (assetsFolder.exists) {
		var assetsFiles = assetsFolder.getFiles();
		for (var i=0; i<assetsFiles.length; i++)
		    assetsFiles[i].remove();
		assetsFolder.remove();
	    }
    
	    if(app.documents.length > 0)
            askAboutBeforeImage();
        
        // logging
        LogEventToHeadlights("swfpanel-Tutorial Builder", "startDemo", 1);     
        
	} catch (e) {
	    alert(e);
	    throw e;
	}
    }



    // the next 4 functions were borrowed from origingal StopRecordTutorial script
    function stopDemo() {
	var self = this;

	try {
	    
	    if(confirm("Do you want to save this tutorial?")){
		if (app.documents.length> 0){
		    var t = "Do you want to save "+app.activeDocument.name+" as an 'After' image?";
		    var confirmed = confirm(t);
		    saveAfterImage(confirmed);
		}
		
		var currSLFile = new File(slCodeFile);
		if (currSLFile.exists){
		    if (showTutDialog()) {
			// Copy relevant files from default destination folder to user-specified destination folder
			currSLFile.copy(new File(destinationFolder+'/ScriptingListenerJS.log'));
			//
			var beforeFile = File(defaultDestinationFolder+'/before.png');
			if(beforeFile.exists)
			    beforeFile.copy(new File(destinationFolder+'/before.png'));
			var afterFile = File(defaultDestinationFolder+'/after.png');
			if(afterFile.exists)
			    afterFile.copy(new File(destinationFolder+'/after.png'));
			//
			var destHtmlFolder = new Folder(destinationFolder+'/html');
			destHtmlFolder.create();
			var destAssetsFolder = new Folder(destinationFolder+'/html/assets');
			destAssetsFolder.create();
			var assetsFolder = Folder(defaultDestinationFolder+'/assets');
			var assetsFiles = assetsFolder.getFiles('*.jpg');
			for (var i=0; i<assetsFiles.length; i++) {
			    var assetsFile = assetsFiles[i];
			    if (assetsFile.exists)
				assetsFile.copy(new File(destinationFolder+'/html/assets/' + assetsFile.name));
			}
		    
			buildTutorial();
            
              // logging
              LogEventToHeadlights("swfpanel-Tutorial Builder", "stopDemo-" + title, 1);     

		    }
		}

		else {
		    var slPath = app.path + '/Scripting/Utilities/ScriptListener.8li';
		    alert("It appears that the ScriptListener plug-in is not installed.  Please copy the plug-in from " + decodeURI(slPath) + ' to the Plug-ins folder ' + decodeURI(PLUGINS_FOLDER));
		}
	    }

	} catch (e) {
	    alert(e);
	    throw(e);
	}
    }



    function saveBeforeImage(saveBeforePNG){

	saveCurrImage(defaultDestinationFolder+'/before',
		      saveBeforePNG, /*saveAssetJPG*/ true);
    }
    
    function saveAfterImage(saveAfterPNG){
	
	saveCurrImage(defaultDestinationFolder+'/after', saveAfterPNG,
		      /*saveAssetJPG*/ false);
    }


    function askAboutBeforeImage(){

	//need to have a check about Tutorial Builder panel being visible.
        
	var t = "Do you want to save "+app.activeDocument.name+" as your 'Before' image?";
	var confirmed = confirm(t);
	saveBeforeImage(confirmed);
	return confirmed;
    }

    function saveCurrImage(imageName, saveBeforeAfterPNG, saveAssetJPG){

	var self = this;

	function _saveAsPNG(file) {
	    if (app.documents.length == 0) {
		return;
	    }
  
	    /* $.writeln('saving ' + file.name); */

	    var doc = undefined;
	    try {
		file.remove();
		app.purge(PurgeTarget.ALLCACHES);
		$.gc();

		doc = app.activeDocument.duplicate();

		if (doc.bitsPerChannel != BitsPerChannelType.EIGHT) {
		    doc.bitsPerChannel = BitsPerChannelType.EIGHT;
		}

		if (doc.mode != DocumentMode.RGB) {
		    doc.changeMode(ChangeMode.RGB);
		}

		if (!BridgeTalk.appName.match(/pseeditor/i)) {
		    doc.convertProfile("sRGB IEC61966-2.1", Intent.PERCEPTUAL);
		}

		var saveOpts = new PNGSaveOptions();

		doc.saveAs(file, saveOpts, true);
		doc.close(SaveOptions.DONOTSAVECHANGES);
		app.purge(PurgeTarget.ALLCACHES);
		$.gc();

	    } catch (e) {
		if (doc) {
		    doc.close(SaveOptions.DONOTSAVECHANGES);
		}

		alert("Failed saving document: " + e);
	    }
	}

	function _savePNGAndJPG(imageName, saveBeforeAfterPNG, saveAssetJPG) {
	    if (app.documents.length == 0) {
		return;
	    }
  
	    /* $.writeln('saving ' + file.name); */

	    var doc = undefined;
	    try {
		var pngName = imageName;
		var jpgName = app.activeDocument.name;
		
		app.purge(PurgeTarget.ALLCACHES);
		$.gc();
		
		if (saveBeforeAfterPNG || saveAssetJPG) {
		    doc = app.activeDocument.duplicate();

		    if (doc.bitsPerChannel != BitsPerChannelType.EIGHT) {
			doc.bitsPerChannel = BitsPerChannelType.EIGHT;
		    }
		    
		    if (doc.mode != DocumentMode.RGB) {
			doc.changeMode(ChangeMode.RGB);
		    }
		    
		    if (!BridgeTalk.appName.match(/pseeditor/i)) {
			doc.convertProfile("sRGB IEC61966-2.1", Intent.PERCEPTUAL);
		    }

		    // resize image based on maximum resolution
		    var oldUnits = app.preferences.rulerUnits;
		    app.preferences.rulerUnits = Units.PIXELS;
		    var scale = Math.sqrt(maxPixelRes/(doc.width*doc.height));
		    if (scale < 1.0)
		  	doc.resizeImage(doc.width*scale,doc.height*scale);

		    app.preferences.rulerUnits = oldUnits;

		    // save before/after png file
		    if (saveBeforeAfterPNG) {
			if (!pngName.endsWith('.png')) {
			    pngName += '.png';
			}
			var file = new File(pngName);
			file.remove();
			var saveOpts = new PNGSaveOptions();
			doc.saveAs(file, saveOpts, true);
		    }
		    // save asset file (as JPG)
		    if (saveAssetJPG) {
			if (!jpgName.endsWith('.jpg')) {
			    jpgName += '.jpg';
			}
			var assetsFolder = new Folder(defaultDestinationFolder + '/assets');
			assetsFolder.create();
			if (assetsFolder.exists) {
			    var file = new File(defaultDestinationFolder + '/assets/' + jpgName);
			    file.remove();
			    var saveOpts = new JPEGSaveOptions();
			    saveOpts.quality = 8;
			    doc.saveAs(file, saveOpts, true);
			}
		    }

		    doc.close(SaveOptions.DONOTSAVECHANGES);
		    app.purge(PurgeTarget.ALLCACHES);
		    $.gc();
		}

	    } catch (e) {
		if (doc) {
		    doc.close(SaveOptions.DONOTSAVECHANGES);
		}

		alert("Failed saving document: " + e);
	    }
	}

	    //if (!imageName.endsWith('.png')) {
	    //imageName += '.png';
	    //}

	//var file = new File(imageName);

	//  $.level = 1; debugger;

	//$.writeln(file.name);
  
	try {
	    // eval(estr);
	    //_saveAsPNG(file);
	    _savePNGAndJPG(imageName, saveBeforeAfterPNG, saveAssetJPG);

	} catch (e) {
	    // $.level = 1; debugger;
	}

    }

    //DIALOG UI

    TBDialogUI = function() {
	var self = this;

	self.title = "Save Tutorial";
	self.notesSize = 50;
	self.winRect = {
	    x: 200,
	    y: 200,
	    w: 700,
	    h: 330
	};
	self.documentation ="Creating tutorial... ";

	//self.iniFile = TBLiteOptions.INI_FILE;
    };

    TBDialogUI.prototype = new GenericUI();

    TBDialogUI.prototype.createPanel = function(pnl) {
	var self = this;

	self.moveWindow(toNumber(100), toNumber(100));

	var xOfs = 20;
	var yOfs = 10;
	var yy = yOfs;
	var xx = xOfs;

	var lw = 100;
	var tw = 500;

	pnl.titleLabel = pnl.add('statictext', [xx,yy,xx+lw,yy+20], 'Title:');
	xx += lw;
	pnl.title = pnl.add('edittext', [xx,yy,xx+tw,yy+20], title);

	yy += 35;
	xx = xOfs;

	pnl.captionLabel = pnl.add('statictext', [xx,yy,xx+lw,yy+20], 'Caption:');
	xx += lw;
	pnl.caption = pnl.add('edittext', [xx,yy,xx+tw,yy+20], caption);

	yy += 35;
	xx = xOfs;

	pnl.authorLabel = pnl.add('statictext', [xx,yy,xx+lw,yy+20], 'Author:');
	xx += lw;
	pnl.author = pnl.add('edittext', [xx,yy,xx+tw,yy+20], author);

	yy += 35;
	xx = xOfs;

	pnl.descriptionLabel = pnl.add('statictext', [xx,yy,xx+lw,yy+20], 'Description:');
	xx += lw;
	pnl.description = pnl.add('edittext', [xx,yy,xx+tw,yy+50], description, {multiline:true});

	yy += 35+20;
	xx = xOfs;

	pnl.add('statictext', [xx,yy,xx+lw,yy+20], 'Save To:');
	xx += lw;
	pnl.htmlFiles = pnl.add('edittext', [xx,yy,xx+tw,yy+20], saveToFolder);
	xx += tw + 5;
	pnl.htmlFilesBrowse = pnl.add('button', [xx,yy,xx+25,yy+20], '...');

	pnl.htmlFilesBrowse.onClick = function() {
	    try {
		var pnl = this.parent;
		var file = Stdlib.selectFolder("Select the folder where you want your tutorial saved",
					       pnl.htmlFiles.text);

		if (file) {
		    pnl.htmlFiles.text = file.fsName;
		}
	    } catch (e) {
		alert(e.toSource());
	    }
	};

	return pnl;
    };


    TBDialogUI.prototype.validatePanel = function(pnl) {
	var self = this;

	try {
    
	    // Title
	    title = pnl.title.text;
	    if (!title) {
		title = defaultTitle;
	    }

	    // Caption
	    caption = pnl.caption.text;
	    if (!caption) {
		caption = defaultCaption;
	    }

	    // Author
	    author = pnl.author.text;
	    if (!author) {
		author = defaultAuthor;
	    }

	    // Description
	    description = pnl.description.text;
	    if (!description) {
		description = defaultDescription;
	    }


	    // HTML destination
	    if (pnl.htmlFiles.text) {
		saveToFolder = pnl.htmlFiles.text;
		var f = new Folder(pnl.htmlFiles.text + '/' + pnl.title.text);
		destinationFolder = decodeURI(f.fsName);

		// Create destination folder if necessary
		if (!f.exists) {
		    var created = f.create();
		    if (!created) {
			return self.errorPrompt("Destination folder " + destinationFolder + " cannot be created.");
		    }
		}
	    } else {
		return self.errorPrompt("Destination folder must be specified");
	    }


	} catch (e) {
	    alert(e.toSource());
	    return false;
	}


	return self;
    };


    function showTutDialog(){
	var ui = new TBDialogUI();
	var m = ui.runUI();
	
	// Return true if user hit "Process", false if "Cancel"
	if (m == undefined)
	    return false;
	else 
	    return true;

    }


} catch (e) {
    alert(e);
    throw e;
}


