//
// Logging to Omniture
//

var loggingInitialized = false;

function logConnectedEvent() {
    
    if(loggingInitialized == false)
	return;

    //would need a dictionary mapping eventNames to eventNumbers. 
    //for now just one event - event2
    s = s_gi(s_account);
    s.events='event2'; 
    s.linkTrackEvents='event2';
    s.linkTrackVars="events";
    s.tl(true, 'o', "connectedToPS");
}


function logShowMeClicked(stepNumber) {

    if(loggingInitialized == false)
	return;

    s = s_gi(s_account);

    //showme
    s.prop10 = document.title+"_"+stepNumber+"_"+"showme";

    //event3 is showme event
    s.events='event3'; 
    s.linkTrackEvents='event3';
    s.linkTrackVars="events,prop10";
    s.tl(true, 'o', "showme");
}


function logSetCurrentStep(stepNumber) {

    if(loggingInitialized == false)
	return;

    s = s_gi(s_account);

    //advanceToNextStep
    s.prop11 = document.title+"_"+stepNumber+"_"+"setCurrentStep";

    //event5 is setCurrentStep event
    s.events='event5'; 
    s.linkTrackEvents='event5';
    s.linkTrackVars="events,prop11";
    s.tl(true, 'o', "setCurrentStep");
}

function logSaveStep(stepNumber) {

    if(loggingInitialized == false)
	return;


    s = s_gi(s_account);

    //advanceToNextStep
    s.prop12 = document.title+"_"+stepNumber+"_"+"saveStep";

    //event6 is save
    s.events='event6'; 
    s.linkTrackEvents='event6';
    s.linkTrackVars="events,prop12";
    s.tl(true, 'o', "saveStep");
}

function logSave() {

    if(loggingInitialized == false)
	return;

    s = s_gi(s_account);
    s.events='event7'; 
    s.linkTrackEvents='event7';
    s.linkTrackVars="events";
    s.tl(true, 'o', "saveTutorial");

}

function logExport() {

    if(loggingInitialized == false)
	return;

    s = s_gi(s_account);
    s.events='event8'; 
    s.linkTrackEvents='event8';
    s.linkTrackVars="events";
    s.tl(true, 'o', "exportTutorial");

}


function initLogging() {

    if(loggingInitialized == false)
	return;

    /* You may give each page an identifying name, server, and channel on
       the next lines. */
    s.pageName=document.title;
    s.server="";
    s.channel="D=c2";
    s.pageType="";
    s.prop1= "";
    if ($(".author").length > 0){
	s.prop2=$(".author")[0].innerHTML; //author
    }else{
	s.prop2 = "";
    }
    s.prop3=$(".step").length; //number of steps
    s.prop4=document.location.protocol; //location
    s.prop5= document.location.href;
    s.prop6=navigator.userAgent; //host
    if($("html").attr("editable")){
	s.prop7="editable"
    }else{
	s.prop7="notEditable"
    }

    /* Conversion Variables */
    s.campaign=""
    s.state=""
    s.zip=""
    s.events="event4"
    s.products=""
    s.purchaseID=""
    s.eVar1="D=pageName" //page name
    s.eVar2="D=c2" //author
    s.eVar3="D=c3" //number of steps
    s.eVar4="D=c4" 
    s.eVar5="D=c5";
    s.eVar6="D=c6";
    s.eVar7="D=c7";
    s.eVar10="D=c10"
    s.eVar11="D=c11"
    s.eVar12="D=c12"

    var s_code=s.t();
    if(s_code)
	document.write(s_code);

    //for debugging
    /*logConnectedEvent()
      logShowMeClicked(1)
      logSetCurrentStep(2)
      logSaveStep(3)
      logExport()*/
    
}

